<?php

// $Header: /cvsroot/moregroupware/mgw/modules/workflow/tiki-g-admin_shared_source.php,v 1.3 2004/04/29 09:42:59 liedekef Exp $

// Copyright (c) 2002-2003, Luis Argerich, Garland Foster, Eduardo Polidor, et. al.
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

require_once ('setup-base.php');
include_once (GALAXIA_LIBRARY.'/ProcessManager.php');

// Remove automatic quotes added to POST/COOKIE by PHP
if (get_magic_quotes_gpc()) {
        foreach ($_REQUEST as $k => $v) {
                if (!is_array($_REQUEST[$k])) $_REQUEST[$k] = stripslashes($v);
        }
}

// The galaxia source editor for activities and
// processes.
if ($feature_workflow != 'y') {
	$smarty->assign('msg', tra("This feature is disabled").": feature_workflow");

	$smarty->display("workflow_error.tpl");
	die;
}

if ($tiki_p_admin_workflow != 'y') {
	$smarty->assign('msg', tra("Permission denied"));

	$smarty->display("workflow_error.tpl");
	die;
}

if (!isset($_REQUEST['pid'])) {
	$smarty->assign('msg', tra("No process indicated"));

	$smarty->display("workflow_error.tpl");
	die;
}

$smarty->assign('pid', $_REQUEST['pid']);

if (isset($_REQUEST['code'])) {
	unset ($_REQUEST['template']);

	$_REQUEST['save'] = 'y';
}

$proc_info = $processManager->get_process($_REQUEST['pid']);
$proc_info['graph']=GALAXIA_PROCESSES.$proc_info['normalized_name']."/graph/".$proc_info['normalized_name'].".png";
$smarty->assign_by_ref('proc_info',$proc_info);

$procname = $proc_info['normalized_name'];

$smarty->assign('warn', '');

if (!isset($_REQUEST['activityId']))
	$_REQUEST['activityId'] = 0;

$smarty->assign('activityId', $_REQUEST['activityId']);

if ($_REQUEST['activityId']) {
	$act_info = $activityManager->get_activity($_REQUEST['pid'], $_REQUEST['activityId']);

	$actname = $act_info['normalized_name'];

	if (isset($_REQUEST['template'])) {
		$smarty->assign('template', 'y');

		$source = GALAXIA_PROCESSES."/$procname/code/templates/$actname" . '.tpl';
	} else {
		$smarty->assign('template', 'n');

		$source = GALAXIA_PROCESSES."/$procname/code/activities/$actname" . '.php';
	}

	// Then editing an activity
	$smarty->assign('act_info', $act_info);
} else {
	// Then editing shared code
	$source = GALAXIA_PROCESSES."/$procname/code/shared.php";
}

//First of all save
if (isset($_REQUEST['source'])) {
	$fp = fopen($_REQUEST['source_name'], "wb");
	fwrite($fp, $_REQUEST['source']);
	fclose ($fp);

	if ($_REQUEST['activityId']) {
		$activityManager->compile_activity($_REQUEST['pid'], $_REQUEST['activityId']);
	}
}

$smarty->assign('source_name', $source);

$fp = fopen($source, "rb");
$data = fread($fp, filesize($source));
fclose ($fp);
$smarty->assign('data', htmlentities($data));

$valid = $activityManager->validate_process_activities($_REQUEST['pid']);
$errors = array();

if (!$valid) {
	$errors = $activityManager->get_error();

	$proc_info['isValid'] = 'n';
} else {
	$proc_info['isValid'] = 'y';
}

$smarty->assign('errors', $errors);

$activities = $activityManager->list_activities($_REQUEST['pid'], 0, -1, 'name_asc', '');
$smarty->assign_by_ref('items', $activities['data']);

$smarty->assign('mid', 'tiki-g-admin_shared_source.tpl');
$smarty->display("tiki.tpl");

?>
